#include <stdio.h>
#include <mpi.h>

const char * get_type( MPI_Datatype type )
{
	switch( type )
	{
		case MPI_INT:
			return "MPI_INT";
		break;
		case MPI_UNSIGNED:
			return "MPI_UNSIGNED";
		break;
		case MPI_UNSIGNED_LONG:
			return "MPI_UNSIGNED_LONG";
		break;
		case MPI_UNSIGNED_LONG_LONG:
			return "MPI_UNSIGNED_LONG_LONG";
		break;
		case MPI_COUNT:
			return "MPI_COUNT";
		break;
		case MPI_CHAR:
			return "MPI_CHAR";
		break;
		case MPI_DOUBLE:
			return "MPI_DOUBLE";
		break;
	}
	
	return "UNKNOWN TYPE";
}

int main(int argc, char **argv)
{
	int provided;
	MPI_T_init_thread(MPI_THREAD_MULTIPLE, &provided );
	
	MPI_Init( &argc, &argv );

	int cvar_count = 0;

	printf("=================================\n");
	printf("This is the MPC MPI_T variable list\n");
	printf("=================================\n");


	printf("[CVARS] ================\n");

	MPI_T_cvar_get_num( &cvar_count );

	char name[500];
	int name_len;
	int verbosity;
	MPI_Datatype datatype;
	MPI_T_enum enumtype;
	char desc[500];
	int desc_len;
	int bind;
	int scope;

	int i;

	for (i = 0; i < cvar_count; ++i) {
		
		MPI_T_cvar_get_info( i,
		name,
		&name_len,
		&verbosity, 
		&datatype,
		&enumtype ,
		desc, 
		&desc_len, 
		&bind, 
		&scope );

		printf("[%d] %s(%s) : %s\n", i, name, get_type( datatype ) , desc );
	}

	printf("[PVARS] ================\n");

	int pvar_count = 0;
	MPI_T_pvar_get_num( &pvar_count );

	int var_class;
	int readonly, continuous, atomic;

	for (i = 0; i < pvar_count; ++i) {
	

		MPI_T_pvar_get_info( i,
		name,
		&name_len,
		&verbosity,
		&var_class,
		&datatype,
		&enumtype,
		desc,
		&desc_len,
		&bind,
		&readonly,
		&continuous,
		&atomic );

		printf("[%d] %s(%s) : %s\n", i, name, get_type( datatype ) , desc );
	}

	
	printf("=============SUMMARY=============\n");
	printf("MPC has %d CVARS and %d PVARS\n", cvar_count, pvar_count );
	printf("=================================\n");




	MPI_Finalize();
	MPI_T_finalize();

	return 0;
}
